diff --git a/src/fe_utils/psqlscan.l b/src/fe_utils/psqlscan.l
index ce20936339..00049a5177 100644
--- a/src/fe_utils/psqlscan.l
+++ b/src/fe_utils/psqlscan.l
@@ -323,10 +323,10 @@ not_equals		"!="
  * appears in the "self" set, it is not to be returned as an Op).  Note
  * that the sets overlap, but each has some chars that are not in the other.
  *
- * If you change either set, adjust the character lists appearing in the
+ * If you change "op_chars", adjust the character list appearing in the
  * rule for "operator"!
  */
-self			[,()\[\].;\:\+\-\*\/\%\^\<\>\=]
+self			[,()\[\]{}.;\:\+\-\*\/\%\^\<\>\=]
 op_chars		[\~\!\@\#\^\&\|\`\?\+\-\*\/\%\<\>\=]
 operator		{op_chars}+
 
diff --git a/src/include/parser/scanner.h b/src/include/parser/scanner.h
index 731a2bd264..27e63cbfc8 100644
--- a/src/include/parser/scanner.h
+++ b/src/include/parser/scanner.h
@@ -52,6 +52,9 @@ typedef union core_YYSTYPE
  *	%token <ival>	ICONST PARAM
  *	%token			TYPECAST DOT_DOT COLON_EQUALS EQUALS_GREATER
  *	%token			LESS_EQUALS GREATER_EQUALS NOT_EQUALS
+ *	%token			COMMA LPAREN RPAREN LBRACKET RBRACKET LBRACE RBRACE DOT
+ *	%token			SEMICOLON COLON PLUS MINUS STAR SLASH
+ *	%token			PERCENT CARET LESS GREATER EQUALS
  * The above token definitions *must* be the first ones declared in any
  * bison parser built atop this scanner, so that they will have consistent
  * numbers assigned to them (specifically, IDENT = 258 and so on).
diff --git a/src/interfaces/ecpg/preproc/ecpg.addons b/src/interfaces/ecpg/preproc/ecpg.addons
index 300381eaad..0437798c93 100644
--- a/src/interfaces/ecpg/preproc/ecpg.addons
+++ b/src/interfaces/ecpg/preproc/ecpg.addons
@@ -413,7 +413,7 @@ ECPG: TypenameSimpleTypenameopt_array_bounds block
 	{	$$ = cat2_str($1, $2.str); }
 ECPG: TypenameSETOFSimpleTypenameopt_array_bounds block
 	{	$$ = cat_str(3, mm_strdup("setof"), $2, $3.str); }
-ECPG: opt_array_boundsopt_array_bounds'['']' block
+ECPG: opt_array_boundsopt_array_boundsLBRACKETRBRACKET block
 	{
 		$$.index1 = $1.index1;
 		$$.index2 = $1.index2;
@@ -423,7 +423,7 @@ ECPG: opt_array_boundsopt_array_bounds'['']' block
 			$$.index2 = mm_strdup("0");
 		$$.str = cat_str(2, $1.str, mm_strdup("[]"));
 	}
-	| opt_array_bounds '[' Iresult ']'
+	| opt_array_bounds LBRACKET Iresult RBRACKET
 	{
 		$$.index1 = $1.index1;
 		$$.index2 = $1.index2;
@@ -511,7 +511,7 @@ ECPG: FetchStmtMOVEfetch_args rule
 		add_additional_variables($4, false);
 		$$ = cat_str(2, mm_strdup("move backward from"), cursor_marker);
 	}
-ECPG: limit_clauseLIMITselect_limit_value','select_offset_value block
+ECPG: limit_clauseLIMITselect_limit_valueCOMMAselect_offset_value block
 	{
 		mmerror(PARSE_ERROR, ET_WARNING, "no longer supported LIMIT #,# syntax passed to server");
 		$$ = cat_str(4, mm_strdup("limit"), $2, mm_strdup(","), $4);
diff --git a/src/interfaces/ecpg/preproc/ecpg.trailer b/src/interfaces/ecpg/preproc/ecpg.trailer
index f58b41e675..70e94535db 100644
--- a/src/interfaces/ecpg/preproc/ecpg.trailer
+++ b/src/interfaces/ecpg/preproc/ecpg.trailer
@@ -4,8 +4,8 @@ statements: /*EMPTY*/
 				| statements statement
 		;
 
-statement: ecpgstart at stmt ';' { connection = NULL; }
-				| ecpgstart stmt ';'
+statement: ecpgstart at stmt SEMICOLON { connection = NULL; }
+				| ecpgstart stmt SEMICOLON
 				| ecpgstart ECPGVarDeclaration
 				{
 					fprintf(base_yyout, "%s", $2);
@@ -15,8 +15,8 @@ statement: ecpgstart at stmt ';' { connection = NULL; }
 				| ECPGDeclaration
 				| c_thing               { fprintf(base_yyout, "%s", $1); free($1); }
 				| CPP_LINE              { fprintf(base_yyout, "%s", $1); free($1); }
-				| '{'                   { braces_open++; fputs("{", base_yyout); }
-				| '}'
+				| LBRACE                   { braces_open++; fputs("{", base_yyout); }
+				| RBRACE
 		{
 			remove_typedefs(braces_open);
 			remove_variables(braces_open--);
@@ -83,7 +83,7 @@ connection_target: opt_database_name opt_server opt_port
 			else
 				$$ = make3_str(mm_strdup("\""), make3_str($1, $2, $3), mm_strdup("\""));
 		}
-		|  db_prefix ':' server opt_port '/' opt_database_name opt_options
+		|  db_prefix COLON server opt_port SLASH opt_database_name opt_options
 		{
 			/* new style: <tcp|unix>:postgresql://server[:port][/dbname] */
 			if (strncmp($1, "unix:postgresql", strlen("unix:postgresql")) != 0 && strncmp($1, "tcp:postgresql", strlen("tcp:postgresql")) != 0)
@@ -144,11 +144,11 @@ opt_server: server			{ $$ = $1; }
 		;
 
 server_name: ColId					{ $$ = $1; }
-		| ColId '.' server_name		{ $$ = make3_str($1, mm_strdup("."), $3); }
+		| ColId DOT server_name		{ $$ = make3_str($1, mm_strdup("."), $3); }
 		| IP						{ $$ = make_name(); }
 		;
 
-opt_port: ':' Iconst		{ $$ = make2_str(mm_strdup(":"), $2); }
+opt_port: COLON Iconst		{ $$ = make2_str(mm_strdup(":"), $2); }
 		| /*EMPTY*/	{ $$ = EMPTY; }
 		;
 
@@ -162,7 +162,7 @@ opt_user: USER ora_user		{ $$ = $2; }
 
 ora_user: user_name
 			{ $$ = cat2_str($1, mm_strdup(", NULL")); }
-		| user_name '/' user_name
+		| user_name SLASH user_name
 			{ $$ = cat_str(3, $1, mm_strdup(","), $3); }
 		| user_name SQL_IDENTIFIED BY user_name
 			{ $$ = cat_str(3, $1, mm_strdup(","), $4); }
@@ -265,11 +265,11 @@ connect_options:  ColId opt_opt_value
 
 opt_opt_value: /*EMPTY*/
 			{ $$ = EMPTY; }
-		| '=' Iconst
+		| EQUALS Iconst
 			{ $$ = make2_str(mm_strdup("="), $2); }
-		| '=' ecpg_ident
+		| EQUALS ecpg_ident
 			{ $$ = make2_str(mm_strdup("="), $2); }
-		| '=' civar
+		| EQUALS civar
 			{ $$ = make2_str(mm_strdup("="), $2); }
 		;
 
@@ -368,7 +368,7 @@ single_vt_declaration: type_declaration		{ $$ = $1; }
 
 precision:	NumericOnly	{ $$ = $1; };
 
-opt_scale:	',' NumericOnly	{ $$ = $2; }
+opt_scale:	COMMA NumericOnly	{ $$ = $2; }
 		| /* EMPTY */	{ $$ = EMPTY; }
 		;
 
@@ -392,9 +392,9 @@ ECPGDeclaration: sql_startdeclare
 		}
 		;
 
-sql_startdeclare: ecpgstart BEGIN_P DECLARE SQL_SECTION ';' {};
+sql_startdeclare: ecpgstart BEGIN_P DECLARE SQL_SECTION SEMICOLON {};
 
-sql_enddeclare: ecpgstart END_P DECLARE SQL_SECTION ';' {};
+sql_enddeclare: ecpgstart END_P DECLARE SQL_SECTION SEMICOLON {};
 
 var_type_declarations:	/*EMPTY*/			{ $$ = EMPTY; }
 		| vt_declarations			{ $$ = $1; }
@@ -416,7 +416,7 @@ type_declaration: S_TYPEDEF
 		/* an initializer specified */
 		initializer = 0;
 	}
-	var_type opt_pointer ECPGColLabelCommon opt_array_bounds ';'
+	var_type opt_pointer ECPGColLabelCommon opt_array_bounds SEMICOLON
 	{
 		add_typedef($5, $6.index1, $6.index2, $3.type_enum, $3.type_dimension, $3.type_index, initializer, *$4 ? 1 : 0);
 
@@ -436,7 +436,7 @@ var_declaration: storage_declaration
 
 			actual_startline[struct_level] = hashline_number();
 		}
-		variable_list ';'
+		variable_list SEMICOLON
 		{
 			$$ = cat_str(5, actual_startline[struct_level], $1, $2.type_str, $4, mm_strdup(";\n"));
 		}
@@ -450,17 +450,17 @@ var_declaration: storage_declaration
 
 			actual_startline[struct_level] = hashline_number();
 		}
-		variable_list ';'
+		variable_list SEMICOLON
 		{
 			$$ = cat_str(4, actual_startline[struct_level], $1.type_str, $3, mm_strdup(";\n"));
 		}
-		| struct_union_type_with_symbol ';'
+		| struct_union_type_with_symbol SEMICOLON
 		{
 			$$ = cat2_str($1, mm_strdup(";"));
 		}
 		;
 
-opt_bit_field:	':' Iconst	{ $$ =cat2_str(mm_strdup(":"), $2); }
+opt_bit_field:	COLON Iconst	{ $$ =cat2_str(mm_strdup(":"), $2); }
 		| /* EMPTY */	{ $$ = EMPTY; }
 		;
 
@@ -513,7 +513,7 @@ var_type:	simple_type
 			$$.type_index = mm_strdup("-1");
 			$$.type_sizeof = NULL;
 		}
-		| ECPGColLabelCommon '(' precision opt_scale ')'
+		| ECPGColLabelCommon LPAREN precision opt_scale RPAREN
 		{
 			if (strcmp($1, "numeric") == 0)
 			{
@@ -692,7 +692,7 @@ enum_type: ENUM_P symbol enum_definition
 			{ $$ = cat2_str(mm_strdup("enum"), $2); }
 		;
 
-enum_definition: '{' c_list '}'
+enum_definition: LBRACE c_list RBRACE
 			{ $$ = cat_str(3, mm_strdup("{"), $2, mm_strdup("}")); };
 
 struct_union_type_with_symbol: s_struct_union_symbol
@@ -702,7 +702,7 @@ struct_union_type_with_symbol: s_struct_union_symbol
 				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
 			forward_name = mm_strdup($1.symbol);
 		}
-		'{' variable_declarations '}'
+		LBRACE variable_declarations RBRACE
 		{
 			struct typedefs *ptr, *this;
 			struct this_type su_type;
@@ -753,7 +753,7 @@ struct_union_type: struct_union_type_with_symbol	{ $$ = $1; }
 			if (struct_level >= STRUCT_DEPTH)
 				 mmerror(PARSE_ERROR, ET_ERROR, "too many levels in nested structure/union definition");
 		}
-		'{' variable_declarations '}'
+		LBRACE variable_declarations RBRACE
 		{
 			ECPGfree_struct_member(struct_member_list[struct_level]);
 			struct_member_list[struct_level] = NULL;
@@ -819,7 +819,7 @@ opt_signed: SQL_SIGNED
 
 variable_list: variable
 			{ $$ = $1; }
-		| variable_list ',' variable
+		| variable_list COMMA variable
 		{
 			if (actual_type[struct_level].type_enum == ECPGt_varchar || actual_type[struct_level].type_enum == ECPGt_bytea)
 				$$ = cat_str(3, $1, mm_strdup(";"), $3);
@@ -929,7 +929,7 @@ variable: opt_pointer ECPGColLabel opt_array_bounds opt_bit_field opt_initialize
 
 opt_initializer: /*EMPTY*/
 			{ $$ = EMPTY; }
-		| '=' c_term
+		| EQUALS c_term
 		{
 			initializer = 1;
 			$$ = cat2_str(mm_strdup("="), $2);
@@ -937,8 +937,8 @@ opt_initializer: /*EMPTY*/
 		;
 
 opt_pointer: /*EMPTY*/				{ $$ = EMPTY; }
-		| '*'						{ $$ = mm_strdup("*"); }
-		| '*' '*'					{ $$ = mm_strdup("**"); }
+		| STAR						{ $$ = mm_strdup("*"); }
+		| STAR STAR					{ $$ = mm_strdup("**"); }
 		;
 
 /*
@@ -1031,7 +1031,7 @@ into_sqlda: INTO name
 		}
 		;
 
-using_list: UsingValue | UsingValue ',' using_list;
+using_list: UsingValue | UsingValue COMMA using_list;
 
 UsingValue: UsingConst
 		{
@@ -1045,11 +1045,11 @@ UsingValue: UsingConst
 		;
 
 UsingConst: Iconst			{ $$ = $1; }
-		| '+' Iconst		{ $$ = cat_str(2, mm_strdup("+"), $2); }
-		| '-' Iconst		{ $$ = cat_str(2, mm_strdup("-"), $2); }
+		| PLUS Iconst		{ $$ = cat_str(2, mm_strdup("+"), $2); }
+		| MINUS Iconst		{ $$ = cat_str(2, mm_strdup("-"), $2); }
 		| ecpg_fconst		{ $$ = $1; }
-		| '+' ecpg_fconst	{ $$ = cat_str(2, mm_strdup("+"), $2); }
-		| '-' ecpg_fconst	{ $$ = cat_str(2, mm_strdup("-"), $2); }
+		| PLUS ecpg_fconst	{ $$ = cat_str(2, mm_strdup("+"), $2); }
+		| MINUS ecpg_fconst	{ $$ = cat_str(2, mm_strdup("-"), $2); }
 		| ecpg_sconst		{ $$ = $1; }
 		| ecpg_bconst		{ $$ = $1; }
 		| ecpg_xconst		{ $$ = $1; }
@@ -1138,10 +1138,10 @@ ECPGGetDescriptorHeader: SQL_GET SQL_DESCRIPTOR quoted_ident_stringvar ECPGGetDe
 		;
 
 ECPGGetDescHeaderItems: ECPGGetDescHeaderItem
-		| ECPGGetDescHeaderItems ',' ECPGGetDescHeaderItem
+		| ECPGGetDescHeaderItems COMMA ECPGGetDescHeaderItem
 		;
 
-ECPGGetDescHeaderItem: cvariable '=' desc_header_item
+ECPGGetDescHeaderItem: cvariable EQUALS desc_header_item
 			{ push_assignment($1, $3); }
 		;
 
@@ -1151,10 +1151,10 @@ ECPGSetDescriptorHeader: SET SQL_DESCRIPTOR quoted_ident_stringvar ECPGSetDescHe
 		;
 
 ECPGSetDescHeaderItems: ECPGSetDescHeaderItem
-		| ECPGSetDescHeaderItems ',' ECPGSetDescHeaderItem
+		| ECPGSetDescHeaderItems COMMA ECPGSetDescHeaderItem
 		;
 
-ECPGSetDescHeaderItem: desc_header_item '=' IntConstVar
+ECPGSetDescHeaderItem: desc_header_item EQUALS IntConstVar
 		{
 			push_assignment($3, $1);
 		}
@@ -1186,10 +1186,10 @@ ECPGGetDescriptor:	SQL_GET SQL_DESCRIPTOR quoted_ident_stringvar VALUE_P IntCons
 		;
 
 ECPGGetDescItems: ECPGGetDescItem
-		| ECPGGetDescItems ',' ECPGGetDescItem
+		| ECPGGetDescItems COMMA ECPGGetDescItem
 		;
 
-ECPGGetDescItem: cvariable '=' descriptor_item	{ push_assignment($1, $3); };
+ECPGGetDescItem: cvariable EQUALS descriptor_item	{ push_assignment($1, $3); };
 
 
 ECPGSetDescriptor:	SET SQL_DESCRIPTOR quoted_ident_stringvar VALUE_P IntConstVar ECPGSetDescItems
@@ -1197,10 +1197,10 @@ ECPGSetDescriptor:	SET SQL_DESCRIPTOR quoted_ident_stringvar VALUE_P IntConstVar
 		;
 
 ECPGSetDescItems: ECPGSetDescItem
-		| ECPGSetDescItems ',' ECPGSetDescItem
+		| ECPGSetDescItems COMMA ECPGSetDescItem
 		;
 
-ECPGSetDescItem: descriptor_item '=' AllConstVar
+ECPGSetDescItem: descriptor_item EQUALS AllConstVar
 		{
 			push_assignment($3, $1);
 		}
@@ -1220,7 +1220,7 @@ AllConstVar: ecpg_fconst
 			$$ = $1;
 		}
 
-		| '-' ecpg_fconst
+		| MINUS ecpg_fconst
 		{
 			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
 			char *var = cat2_str(mm_strdup("-"), $2);
@@ -1230,7 +1230,7 @@ AllConstVar: ecpg_fconst
 			$$ = var;
 		}
 
-		| '-' Iconst
+		| MINUS Iconst
 		{
 			char *length = mm_alloc(sizeof(int) * CHAR_BIT * 10 / 3);
 			char *var = cat2_str(mm_strdup("-"), $2);
@@ -1273,7 +1273,7 @@ descriptor_item:	SQL_CARDINALITY			{ $$ = ECPGd_cardinality; }
  * set/reset the automatic transaction mode, this needs a different handling
  * as the other set commands
  */
-ECPGSetAutocommit:	SET SQL_AUTOCOMMIT '=' on_off	{ $$ = $4; }
+ECPGSetAutocommit:	SET SQL_AUTOCOMMIT EQUALS on_off	{ $$ = $4; }
 		|  SET SQL_AUTOCOMMIT TO on_off   { $$ = $4; }
 		;
 
@@ -1286,7 +1286,7 @@ on_off: ON				{ $$ = mm_strdup("on"); }
  * set commands
  */
 ECPGSetConnection:	SET CONNECTION TO connection_object { $$ = $4; }
-		| SET CONNECTION '=' connection_object { $$ = $4; }
+		| SET CONNECTION EQUALS connection_object { $$ = $4; }
 		| SET CONNECTION  connection_object { $$ = $3; }
 		;
 
@@ -1438,7 +1438,7 @@ action : CONTINUE_P
 			$<action>$.command = mm_strdup($3);
 			$<action>$.str = cat2_str(mm_strdup("goto "), $3);
 		}
-		| DO name '(' c_args ')'
+		| DO name LPAREN c_args RPAREN
 		{
 			$<action>$.code = W_DO;
 			$<action>$.command = cat_str(4, $2, mm_strdup("("), $4, mm_strdup(")"));
@@ -1456,7 +1456,7 @@ action : CONTINUE_P
 			$<action>$.command = NULL;
 			$<action>$.str = mm_strdup("continue");
 		}
-		| CALL name '(' c_args ')'
+		| CALL name LPAREN c_args RPAREN
 		{
 			$<action>$.code = W_DO;
 			$<action>$.command = cat_str(4, $2, mm_strdup("("), $4, mm_strdup(")"));
@@ -1627,7 +1627,7 @@ ECPGunreserved_interval: DAY_P				{ $$ = mm_strdup("day"); }
 		;
 
 
-into_list : coutputvariable | into_list ',' coutputvariable
+into_list : coutputvariable | into_list COMMA coutputvariable
 		;
 
 ecpgstart: SQL_START	{
@@ -1772,8 +1772,8 @@ quoted_ident_stringvar: name
  */
 
 c_stuff_item: c_anything			{ $$ = $1; }
-		| '(' ')'			{ $$ = mm_strdup("()"); }
-		| '(' c_stuff ')'
+		| LPAREN RPAREN			{ $$ = mm_strdup("()"); }
+		| LPAREN c_stuff RPAREN
 			{ $$ = cat_str(3, mm_strdup("("), $2, mm_strdup(")")); }
 		;
 
@@ -1783,29 +1783,29 @@ c_stuff: c_stuff_item			{ $$ = $1; }
 		;
 
 c_list: c_term				{ $$ = $1; }
-		| c_list ',' c_term	{ $$ = cat_str(3, $1, mm_strdup(","), $3); }
+		| c_list COMMA c_term	{ $$ = cat_str(3, $1, mm_strdup(","), $3); }
 		;
 
 c_term:  c_stuff			{ $$ = $1; }
-		| '{' c_list '}'	{ $$ = cat_str(3, mm_strdup("{"), $2, mm_strdup("}")); }
+		| LBRACE c_list RBRACE	{ $$ = cat_str(3, mm_strdup("{"), $2, mm_strdup("}")); }
 		;
 
 c_thing:	c_anything		{ $$ = $1; }
-		|	'('		{ $$ = mm_strdup("("); }
-		|	')'		{ $$ = mm_strdup(")"); }
-		|	','		{ $$ = mm_strdup(","); }
-		|	';'		{ $$ = mm_strdup(";"); }
+		|	LPAREN		{ $$ = mm_strdup("("); }
+		|	RPAREN		{ $$ = mm_strdup(")"); }
+		|	COMMA		{ $$ = mm_strdup(","); }
+		|	SEMICOLON	{ $$ = mm_strdup(";"); }
 		;
 
 c_anything:  ecpg_ident				{ $$ = $1; }
 		| Iconst			{ $$ = $1; }
 		| ecpg_fconst			{ $$ = $1; }
 		| ecpg_sconst			{ $$ = $1; }
-		| '*'				{ $$ = mm_strdup("*"); }
-		| '+'				{ $$ = mm_strdup("+"); }
-		| '-'				{ $$ = mm_strdup("-"); }
-		| '/'				{ $$ = mm_strdup("/"); }
-		| '%'				{ $$ = mm_strdup("%"); }
+		| STAR				{ $$ = mm_strdup("*"); }
+		| PLUS				{ $$ = mm_strdup("+"); }
+		| MINUS				{ $$ = mm_strdup("-"); }
+		| SLASH				{ $$ = mm_strdup("/"); }
+		| PERCENT			{ $$ = mm_strdup("%"); }
 		| NULL_P			{ $$ = mm_strdup("NULL"); }
 		| S_ADD				{ $$ = mm_strdup("+="); }
 		| S_AND				{ $$ = mm_strdup("&&"); }
@@ -1849,10 +1849,10 @@ c_anything:  ecpg_ident				{ $$ = $1; }
 		| TO				{ $$ = mm_strdup("to"); }
 		| UNION				{ $$ = mm_strdup("union"); }
 		| VARCHAR			{ $$ = mm_strdup("varchar"); }
-		| '['				{ $$ = mm_strdup("["); }
-		| ']'				{ $$ = mm_strdup("]"); }
-		| '='				{ $$ = mm_strdup("="); }
-		| ':'				{ $$ = mm_strdup(":"); }
+		| LBRACKET			{ $$ = mm_strdup("["); }
+		| RBRACKET			{ $$ = mm_strdup("]"); }
+		| EQUALS			{ $$ = mm_strdup("="); }
+		| COLON				{ $$ = mm_strdup(":"); }
 		;
 
 DeallocateStmt: DEALLOCATE prepared_name                { $$ = $2; }
@@ -1862,15 +1862,15 @@ DeallocateStmt: DEALLOCATE prepared_name                { $$ = $2; }
                 ;
 
 Iresult:        Iconst				{ $$ = $1; }
-                | '(' Iresult ')'		{ $$ = cat_str(3, mm_strdup("("), $2, mm_strdup(")")); }
-                | Iresult '+' Iresult		{ $$ = cat_str(3, $1, mm_strdup("+"), $3); }
-                | Iresult '-' Iresult		{ $$ = cat_str(3, $1, mm_strdup("-"), $3); }
-                | Iresult '*' Iresult		{ $$ = cat_str(3, $1, mm_strdup("*"), $3); }
-                | Iresult '/' Iresult		{ $$ = cat_str(3, $1, mm_strdup("/"), $3); }
-                | Iresult '%' Iresult		{ $$ = cat_str(3, $1, mm_strdup("%"), $3); }
+                | LPAREN Iresult RPAREN		{ $$ = cat_str(3, mm_strdup("("), $2, mm_strdup(")")); }
+                | Iresult PLUS Iresult		{ $$ = cat_str(3, $1, mm_strdup("+"), $3); }
+                | Iresult MINUS Iresult		{ $$ = cat_str(3, $1, mm_strdup("-"), $3); }
+                | Iresult STAR Iresult		{ $$ = cat_str(3, $1, mm_strdup("*"), $3); }
+                | Iresult SLASH Iresult		{ $$ = cat_str(3, $1, mm_strdup("/"), $3); }
+                | Iresult PERCENT Iresult		{ $$ = cat_str(3, $1, mm_strdup("%"), $3); }
                 | ecpg_sconst			{ $$ = $1; }
                 | ColId				{ $$ = $1; }
-		| ColId '(' var_type ')'        { if (pg_strcasecmp($1, "sizeof") != 0)
+		| ColId LPAREN var_type RPAREN        { if (pg_strcasecmp($1, "sizeof") != 0)
 							mmerror(PARSE_ERROR, ET_ERROR, "operator not allowed in variable definition");
 						  else
 							$$ = cat_str(4, $1, mm_strdup("("), $3.type_str, mm_strdup(")"));
diff --git a/src/interfaces/ecpg/preproc/parse.pl b/src/interfaces/ecpg/preproc/parse.pl
index 3619706cdc..435b60745c 100644
--- a/src/interfaces/ecpg/preproc/parse.pl
+++ b/src/interfaces/ecpg/preproc/parse.pl
@@ -52,7 +52,25 @@ my %replace_string = (
 	'EQUALS_GREATER' => '=>',
 	'LESS_EQUALS'    => '<=',
 	'GREATER_EQUALS' => '>=',
-	'NOT_EQUALS'     => '<>',);
+	'NOT_EQUALS'     => '<>',
+	# single character tokens found in the core grammar
+	'COMMA'          => ',',
+	'LPAREN'         => '(',
+	'RPAREN'         => ')',
+	'LBRACKET'       => '[',
+	'RBRACKET'       => ']',
+	'DOT'            => '.',
+	'SEMICOLON'      => ';',
+	'COLON'          => ':',
+	'PLUS'           => '+',
+	'MINUS'          => '-',
+	'STAR'           => '*',
+	'SLASH'          => '/',
+	'PERCENT'        => '%',
+	'CARET'          => '^',
+	'LESS'           => '<',
+	'GREATER'        => '>',
+	'EQUALS'         => '=');
 
 # specific replace_types for specific non-terminals - never include the ':'
 # ECPG-only replace_types are defined in ecpg-replace_types
@@ -92,7 +110,7 @@ my %replace_line = (
 	# some other production rules have to be ignored or replaced
 	'fetch_argsFORWARDopt_from_incursor_name'      => 'ignore',
 	'fetch_argsBACKWARDopt_from_incursor_name'     => 'ignore',
-	"opt_array_boundsopt_array_bounds'['Iconst']'" => 'ignore',
+	"opt_array_boundsopt_array_boundsLBRACKETIconstRBRACKET" => 'ignore',
 	'VariableShowStmtSHOWvar_name' => 'SHOW var_name ecpg_into',
 	'VariableShowStmtSHOWTIMEZONE' => 'SHOW TIME ZONE ecpg_into',
 	'VariableShowStmtSHOWTRANSACTIONISOLATIONLEVEL' =>
diff --git a/src/interfaces/ecpg/preproc/pgc.l b/src/interfaces/ecpg/preproc/pgc.l
index 488c89b7f4..ecc59064df 100644
--- a/src/interfaces/ecpg/preproc/pgc.l
+++ b/src/interfaces/ecpg/preproc/pgc.l
@@ -54,6 +54,7 @@ static bool		include_next;
 #define startlit()	(literalbuf[0] = '\0', literallen = 0)
 static void addlit(char *ytext, int yleng);
 static void addlitchar(unsigned char);
+static int	map_single_char_token(char c);
 static int	process_integer_literal(const char *token, YYSTYPE *lval);
 static void parse_include(void);
 static bool ecpg_isspace(char ch);
@@ -314,10 +315,11 @@ not_equals		"!="
  * appears in the "self" set, it is not to be returned as an Op).  Note
  * that the sets overlap, but each has some chars that are not in the other.
  *
- * If you change either set, adjust the character lists appearing in the
- * rule for "operator"!
+ * If you change "op_chars", adjust the character list appearing in the
+ * rule for "operator", and if you change "self", change map_single_char_token()
+ * to match!
  */
-self			[,()\[\].;\:\+\-\*\/\%\^\<\>\=]
+self			[,()\[\]{}.;\:\+\-\*\/\%\^\<\>\=]
 op_chars		[\~\!\@\#\^\&\|\`\?\+\-\*\/\%\<\>\=]
 operator		{op_chars}+
 
@@ -382,6 +384,8 @@ endif			[eE][nN][dD][iI][fF]
 
 struct			[sS][tT][rR][uU][cC][tT]
 
+c_self			[,()\[\]{};\:\+\-\*\/\%\=]
+
 exec_sql		{exec}{space}*{sql}{space}*
 ipdigit			({digit}|{digit}{digit}|{digit}{digit}{digit})
 ip				{ipdigit}\.{ipdigit}\.{ipdigit}\.{ipdigit}
@@ -762,15 +766,18 @@ cppline			{space}*#([^i][A-Za-z]*|{if}|{ifdef}|{ifndef}|{import})((\/\*[^*/]*\*+
 					return yytext[0];
 				}
 
-{self}			{
+{self}		{
+					int self_token = map_single_char_token(yytext[0]);
+					if (self_token < 0)
+						mmerror(PARSE_ERROR, ET_ERROR, "invalid single character token");
 					/*
-					 * We may find a ';' inside a structure
+					 * We may find a SEMICOLON inside a structure
 					 * definition in a TYPE or VAR statement.
 					 * This is not an EOL marker.
 					 */
-					if (yytext[0] == ';' && struct_level == 0)
+					if (self_token == SEMICOLON && struct_level == 0)
 						BEGIN(C);
-					return yytext[0];
+					return self_token;
 				}
 
 {operator}		{
@@ -842,9 +849,13 @@ cppline			{space}*#([^i][A-Za-z]*|{if}|{ifdef}|{ifndef}|{import})((\/\*[^*/]*\*+
 						 * return it as a character token the same way
 						 * that the "self" rule would have.
 						 */
-						if (nchars == 1 &&
-							strchr(",()[].;:+-*/%^<>=", yytext[0]))
-							return yytext[0];
+						if (nchars == 1)
+						{
+							int self_token = map_single_char_token(yytext[0]);
+							if (self_token > 0)
+								return self_token;
+						}
+
 						/*
 						 * Likewise, if what we have left is two chars, and
 						 * those match the tokens ">=", "<=", "=>", "<>" or
@@ -948,7 +959,7 @@ cppline			{space}*#([^i][A-Za-z]*|{if}|{ifdef}|{ifndef}|{import})((\/\*[^*/]*\*+
 				}
 
 {other}			{
-					return yytext[0];
+					mmerror(PARSE_ERROR, ET_ERROR, "invalid single character token %s", yytext);
 				}
 } /* <SQL> */
 
@@ -1013,7 +1024,8 @@ cppline			{space}*#([^i][A-Za-z]*|{if}|{ifdef}|{ifndef}|{import})((\/\*[^*/]*\*+
 						/*
 						 * Try to detect a function name:
 						 * look for identifiers at the global scope
-						 * keep the last identifier before the first '(' and '{'
+						 * keep the last identifier before the first
+						 * LPAREN and LBRACE
 						 */
 						if (braces_open == 0 && parenths_open == 0)
 						{
@@ -1038,22 +1050,19 @@ cppline			{space}*#([^i][A-Za-z]*|{if}|{ifdef}|{ifndef}|{import})((\/\*[^*/]*\*+
 						}
 					}
 <C>{xcstop}			{ mmerror(PARSE_ERROR, ET_ERROR, "nested /* ... */ comments"); }
-<C>":"				{ return ':'; }
-<C>";"				{ return ';'; }
-<C>","				{ return ','; }
-<C>"*"				{ return '*'; }
-<C>"%"				{ return '%'; }
-<C>"/"				{ return '/'; }
-<C>"+"				{ return '+'; }
-<C>"-"				{ return '-'; }
-<C>"("				{ parenths_open++; return '('; }
-<C>")"				{ parenths_open--; return ')'; }
+<C>{c_self}			{
+						int self_token = map_single_char_token(yytext[0]);
+						if (self_token < 0)
+							mmerror(PARSE_ERROR, ET_ERROR, "invalid single character token %s", yytext);
+
+						if (self_token == LPAREN)
+							parenths_open++;
+						if (self_token == RPAREN)
+							parenths_open--;
+
+						return self_token;
+					}
 <C,xskip>{space}		{ ECHO; }
-<C>\{				{ return '{'; }
-<C>\}				{ return '}'; }
-<C>\[				{ return '['; }
-<C>\]				{ return ']'; }
-<C>\=				{ return '='; }
 <C>"->"				{ return S_MEMBER; }
 <C>">>"				{ return S_RSHIFT; }
 <C>"<<"				{ return S_LSHIFT; }
@@ -1472,6 +1481,58 @@ addlitchar(unsigned char ychar)
 	literalbuf[literallen] = '\0';
 }
 
+/*
+ * Return tokens for single characters matching the "self" and "c-self" rules.
+ * Note: This must match the function in gram.y of the same name.
+ */
+static int
+map_single_char_token(char c)
+{
+	switch (c)
+	{
+		case ',':
+			return COMMA;
+		case '(':
+			return LPAREN;
+		case ')':
+			return RPAREN;
+		case '[':
+			return LBRACKET;
+		case ']':
+			return RBRACKET;
+		case '{':
+			return LBRACE;
+		case '}':
+			return RBRACE;
+		case '.':
+			return DOT;
+		case ';':
+			return SEMICOLON;
+		case ':':
+			return COLON;
+		case '+':
+			return PLUS;
+		case '-':
+			return MINUS;
+		case '*':
+			return STAR;
+		case '/':
+			return SLASH;
+		case '%':
+			return PERCENT;
+		case '^':
+			return CARET;
+		case '<':
+			return LESS;
+		case '>':
+			return GREATER;
+		case '=':
+			return EQUALS;
+		default:
+			return -1;
+	}
+}
+
 /*
  * Process {integer}.  Note this will also do the right thing with {decimal},
  * ie digits and a decimal point.
